angular.module('beamng.apps')
.directive('busDispctrl', ['$sce', function ($sce) {
  return {
    templateUrl:  '/ui/modules/apps/BusDispCtrl/app.html',
    replace: true,
    restrict: 'EA',
    require: '^bngApp',
    link: function ($scope, element, attrs, ctrl) {
 
      const settingspath = '/settings/BusDispCtrl/settings.json';
      $scope.lastsettingspath = '/settings/BusDispCtrl/lastsettings.json';
      const minipath = '/settings/BusDispCtrl/minimize.json';
      const verpath = '/ui/modules/apps/BusDispCtrl/app.json';
		$scope.saveid = [0];
		$scope.rowcolour = ["#506070"];
		for (i = 1; i < 20; i++) {
			$scope.saveid.push(i);
			if (i % 2 == 1) {
				$scope.rowcolour.push("#203040");
			} else {
				$scope.rowcolour.push("#506070");
			}
		};
		var newSettings = [{
			saveno: "1",
			savedest: "Destinaton 1",
			savecolour: "#B40404"
		},{
			saveno: "2",
			savedest: "Destinaton 2",
			savecolour: "#B43104"
		},{
			saveno: "3",
			savedest: "Destinaton 3",
			savecolour: "#B45F04"
		},{
			saveno: "4",
			savedest: "Destinaton 4",
			savecolour: "#B18904"
		},{
			saveno: "5",
			savedest: "Destinaton 5",
			savecolour: "#AEB404"
		},{
			saveno: "6",
			savedest: "Destinaton 6",
			savecolour: "#86B404"
		},{
			saveno: "7",
			savedest: "Destinaton 7",
			savecolour: "#5FB404"
		},{
			saveno: "8",
			savedest: "Destinaton 8",
			savecolour: "#31B404"
		},{
			saveno: "9",
			savedest: "Destinaton 9",
			savecolour: "#04B404"
		},{
			saveno: "10",
			savedest: "Destinaton 10",
			savecolour: "#04B431"
		},{
			saveno: "11",
			savedest: "Destinaton 11",
			savecolour: "#04B45F"
		},{
			saveno: "12",
			savedest: "Destinaton 12",
			savecolour: "#04B486"
		},{
			saveno: "13",
			savedest: "Destinaton 13",
			savecolour: "#04B4AE"
		},{
			saveno: "14",
			savedest: "Destinaton 14",
			savecolour: "#0489B1"
		},{
			saveno: "15",
			savedest: "Destinaton 15",
			savecolour: "#045FB4"
		},{
			saveno: "16",
			savedest: "Destinaton 16",
			savecolour: "#0431B4"
		},{
			saveno: "17",
			savedest: "Destinaton 17",
			savecolour: "#0404B4"
		},{
			saveno: "18",
			savedest: "Destinaton 18",
			savecolour: "#3104B4"
		},{
			saveno: "19",
			savedest: "Destinaton 19",
			savecolour: "#5F04B4"
		},{
			saveno: "20",
			savedest: "Destinaton 20",
			savecolour: "#8904B1"
		}];
		$scope.appSettings = newSettings;
		var newlastSettings = {
			setrouteno: "",
			setdest: "",
			setroutecol: "#000000"
		};
		$scope.setdisp = newlastSettings;
		
		$scope.imgformats = [{
			formatid: 1,
			format: ".png"
		},{
			formatid: 2,
			format: ".jpg"
		},{
			formatid: 3,
			format: ".bmp"
		},{
			formatid: 4,
			format: ".webp"
		}];
		
      ctrl.getSettings = function (settings) {
        bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua(settingspath) + ')', (settings) => {
		if (settings == null) {return;}
		for (let i = 0; i < 20; i++) {
			  $scope.appSettings[i].saveno = settings[i].saveno;
			  $scope.appSettings[i].savedest = settings[i].savedest;
			  $scope.appSettings[i].savecolour = settings[i].savecolour;
			  $scope.appSettings[i].saveextra1 = settings[i].saveextra1;
			  $scope.appSettings[i].saveextra2 = settings[i].saveextra2;
			  $scope.appSettings[i].saveextra1r = settings[i].saveextra1r;
			  $scope.appSettings[i].saveextra2r = settings[i].saveextra2r;
			  $scope.appSettings[i].saveint = settings[i].saveint;
			  $scope.appSettings[i].savedestimg = settings[i].savedestimg;
			  $scope.appSettings[i].saveextra1img = settings[i].saveextra1img;
			  $scope.appSettings[i].saveextra2img = settings[i].saveextra2img;
			  $scope.appSettings[i].saverouteimg = settings[i].saverouteimg;
		}
		});
      };
      ctrl.getlastSettings = function (lastsettings) {
        bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua($scope.lastsettingspath) + ')', (lastsettings) => {
			if (lastsettings == null) {return;}
			  $scope.setdisp.setrouteno = lastsettings.setrouteno;
			  $scope.setdisp.setdest = lastsettings.setdest;
			  $scope.setdisp.setroutecol = lastsettings.setroutecol;
			  $scope.setdisp.setextra1 = lastsettings.setextra1;
			  $scope.setdisp.setextra2 = lastsettings.setextra2;
			  $scope.setdisp.setextra1r = lastsettings.setextra1r;
			  $scope.setdisp.setextra2r = lastsettings.setextra2r;
			  $scope.setdisp.setint = lastsettings.setint;
			  $scope.setdisp.setdestimg = lastsettings.setdestimg;
			  $scope.setdisp.setextra1img = lastsettings.setextra1img;
			  $scope.setdisp.setextra2img = lastsettings.setextra2img;
			  $scope.setdisp.setrouteimg = lastsettings.setrouteimg;
		});
      };

      ctrl.saveSettings = function (settings) {
        bngApi.engineLua('jsonWriteFile(' + bngApi.serializeToLua(settingspath) + ', ' + bngApi.serializeToLua(settings) + ', ' + bngApi.serializeToLua(true) + ')');
      };
	  
      ctrl.savemini = function (mini) {
		var savemn = [{
			minimize: mini
		}];
        bngApi.engineLua('jsonWriteFile(' + bngApi.serializeToLua(minipath) + ', ' + bngApi.serializeToLua(savemn) + ', ' + bngApi.serializeToLua(true) + ')');
      };
	  
		  $scope.toggleAll = function() {
			$scope.visible = !$scope.visible;
			if($scope.visible == false) {
			  $scope.appStyle = {appWidth: '170px', appHeight: '16px', appShow: 'hidden', miniWidth: '170px'};
			  $scope.cornerChar = '[Expand] Bus Display Controller';
			} else {
			  $scope.appStyle = {appWidth: '100%', appHeight: '100%', appShow: 'visible', miniWidth: '16px'};
			  $scope.cornerChar = '[Minimize]';
			}
			ctrl.savemini(!$scope.visible);
		  };
		  
      ctrl.getmini = function (minimize) {
        bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua(minipath) + ')', (minimize) => {
			if (minimize == null) {return;}
			if(minimize[0].minimize == true) {
				$scope.toggleAll();
			}
		});
      };
	  
      element.ready(function () {
		  var appjson = null;
			bngApi.engineLua('jsonReadFile(' + bngApi.serializeToLua(verpath) + ')', (appjson) => {
				if (appjson != null) {$scope.appversion = appjson.version;}
			});
		  var loadsettings = null;
		  var loadlastsettings = null;
		  var loadmini = null;
        ctrl.getSettings(loadsettings);
            if(loadsettings != null) {$scope.appSettings = loadsettings};
        ctrl.getlastSettings(loadlastsettings);
            if(loadlastsettings != null) {$scope.setdisp = loadlastsettings};
        ctrl.getmini(loadmini);
            if(loadmini == null) {ctrl.savemini(false);};
      });
	  
		  function componentToHex(c) {
			var hex = c.toString(16);
			return hex.length == 1 ? "0" + hex : hex;
			}

			function rgbToHex(r, g, b) {
			return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
			}
			
		  $scope.savesetting = function () {
			  $scope.appSettings[$scope.selectedId].saveno = $scope.cusrouteno;
			  $scope.appSettings[$scope.selectedId].savedest = $scope.cusdest;
			  $scope.appSettings[$scope.selectedId].savecolour = rgbToHex($scope.cuscolor.red, $scope.cuscolor.green, $scope.cuscolor.blue);
			  $scope.appSettings[$scope.selectedId].saveextra1 = $scope.cusextra1;
			  $scope.appSettings[$scope.selectedId].saveextra2 = $scope.cusextra2;
			  $scope.appSettings[$scope.selectedId].saveextra1r = $scope.cusextra1r;
			  $scope.appSettings[$scope.selectedId].saveextra2r = $scope.cusextra2r;
			  $scope.appSettings[$scope.selectedId].saveint = $scope.cusinterval;
			  $scope.appSettings[$scope.selectedId].savedestimg = $scope.cusdestimg;
			  $scope.appSettings[$scope.selectedId].saveextra1img = $scope.cusextra1img;
			  $scope.appSettings[$scope.selectedId].saveextra2img = $scope.cusextra2img;
			  $scope.appSettings[$scope.selectedId].saverouteimg = $scope.cusrouteimg;
			ctrl.saveSettings($scope.appSettings);
		  };
		  
    },
    controller: function ($scope, $element, $attrs) {
		$scope.appStyle = {appWidth: '100%', appHeight: '100%', appShow: 'visible', miniWidth: '16px'};
		$scope.visible = true;
		$scope.disabled = true;
		$scope.cornerChar = '[Minimize]';
		$scope.cusrouteno = ""
		$scope.cusdest = ""
		$scope.cusextra1 = ""
		$scope.cusextra2 = ""
		$scope.cusextra1r = ""
		$scope.cusextra2r = ""
		$scope.cusinterval = 3
		$scope.cusdestimg = 0
		$scope.cusextra1img = 0
		$scope.cusextra2img = 0
		$scope.cusrouteimg = 0
		$scope.selectedId = "0"
		$scope.selectedicon = ""
		$scope.imgtooltip = "Click here to open the image folder and place the image to be displayed in the folder. Signs type marked with (BusDispCtrl 2.1) is required for Wentward buses to display images."
		  this.randomcolour = function() {
			$scope.cuscolor = {
			  red: Math.floor(Math.random() * 255),
			  green: Math.floor(Math.random() * 255),
			  blue: Math.floor(Math.random() * 255)
			};
		  };
		  this.randomcolour();
		  this.setcolour = function(r,g,b) {
			$scope.cuscolor = {
			  red: r,
			  green: g,
			  blue: b
			};
		  };
		  this.savelastSettings = function (lastsettings) {
			bngApi.engineLua('jsonWriteFile(' + bngApi.serializeToLua($scope.lastsettingspath) + ', ' + bngApi.serializeToLua(lastsettings) + ', ' + bngApi.serializeToLua(true) + ')');
		  };
		  this.setingameroute = function() {
			var cmd = `controller.onGameplayEvent("bus_onRouteChange", {direction="`+$scope.setdisp.setdest+`", routeID="`+$scope.setdisp.setrouteno+`", routeColor="`+$scope.setdisp.setroutecol+`", displaytext="`+$scope.setdisp.setdest+`", displaytextrear="`+$scope.setdisp.setrouteno+`", extratext1="`+$scope.setdisp.setextra1+`", extratext2="`+$scope.setdisp.setextra2+`", interval="`+$scope.setdisp.setint+`", extratext1r="`+$scope.setdisp.setextra1r+`", extratext2r="`+$scope.setdisp.setextra2r+`", displayimg="`+$scope.setdisp.setdestimg+`", destimg="`+$scope.setdisp.setdestimg+`", extratext1img="`+$scope.setdisp.setextra1img+`", extratext2img="`+$scope.setdisp.setextra2img+`", routeimg="`+$scope.setdisp.setrouteimg+`"})`;
			bngApi.activeObjectLua(cmd);
			this.savelastSettings($scope.setdisp);
		  };
		  this.setroute = function(routeno,dest,colour,extra1 = "",extra2 = "",intv = 3,extra1r = "",extra2r = "",destimg = 0,extra1img = 0,extra2img = 0,routeimg = 0) {
			$scope.setdisp.setrouteno = routeno;
			$scope.setdisp.setdest = dest;
			$scope.setdisp.setroutecol = colour;
			$scope.setdisp.setextra1 = extra1;
			$scope.setdisp.setextra2 = extra2;
			$scope.setdisp.setextra1r = extra1r;
			$scope.setdisp.setextra2r = extra2r;
			$scope.setdisp.setint = intv;
			$scope.setdisp.setdestimg = destimg;
			$scope.setdisp.setextra1img = extra1img;
			$scope.setdisp.setextra2img = extra2img;
			$scope.setdisp.setrouteimg = routeimg;
			this.setingameroute();
		  };
		  function componentToHex(c) {
			var hex = c.toString(16);
			return hex.length == 1 ? "0" + hex : hex;
			}

			function rgbToHex(r, g, b) {
			return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
			}
		  this.setcusdisp = function() {
			$scope.setdisp.setrouteno = $scope.cusrouteno;
			$scope.setdisp.setdest = $scope.cusdest;
			$scope.setdisp.setroutecol = rgbToHex($scope.cuscolor.red, $scope.cuscolor.green, $scope.cuscolor.blue);
			$scope.setdisp.setextra1 = $scope.cusextra1;
			$scope.setdisp.setextra2 = $scope.cusextra2;
			$scope.setdisp.setextra1r = $scope.cusextra1r;
			$scope.setdisp.setextra2r = $scope.cusextra2r;
			$scope.setdisp.setint = $scope.cusinterval;
			if ($scope.cusdestimg != 0) {this.cusimg("cus_destimg",$scope.cusdestimgformat);}
			if ($scope.cusextra1img != 0) {this.cusimg("cus_extra1img",$scope.cusextra1imgformat);}
			if ($scope.cusextra2img != 0) {this.cusimg("cus_extra2img",$scope.cusextra2imgformat);}
			if ($scope.cusrouteimg != 0) {this.cusimg("cus_routeimg",$scope.cusrouteimgformat);}
			$scope.setdisp.setdestimg = $scope.cusdestimg;
			$scope.setdisp.setextra1img = $scope.cusextra1img;
			$scope.setdisp.setextra2img = $scope.cusextra2img;
			$scope.setdisp.setrouteimg = $scope.cusrouteimg;
			this.setingameroute();
		  };
		  function hexToRgb(hex) {
			var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
			return result ? {
				r: parseInt(result[1], 16),
				g: parseInt(result[2], 16),
				b: parseInt(result[3], 16)
			} : null;
			}
		  this.cusimg = function(item,val) {
			  var newval = val;
			  document.getElementById(item + '0').style.background = "transparent";
			  document.getElementById(item + '1').style.background = "transparent";
			  if (val >= 1) {newval = 1;}
			  document.getElementById(item + newval.toString()).style.background = "#FF6600";
			  if (item == "cus_destimg") {
				  if (val >= 1) {$scope.cusdestimgformat = val;}
				$scope.cusdestimg = val;
			  } else if (item == "cus_extra1img") {
				  if (val >= 1) {$scope.cusextra1imgformat = val;}
				$scope.cusextra1img = val;
			  } else if (item == "cus_extra2img") {
				  if (val >= 1) {$scope.cusextra2imgformat = val;}
				$scope.cusextra2img = val;
			  } else if (item == "cus_routeimg") {
				  if (val >= 1) {$scope.cusrouteimgformat = val;}
				$scope.cusrouteimg = val;
			  }
		  };
		  this.loadcusdisp = function() {
			$scope.cusrouteno = $scope.setdisp.setrouteno;
			$scope.cusdest = $scope.setdisp.setdest;
			$scope.cuscolor = {
			  red: hexToRgb($scope.setdisp.setroutecol).r,
			  green: hexToRgb($scope.setdisp.setroutecol).g,
			  blue: hexToRgb($scope.setdisp.setroutecol).b
			};
			$scope.cusextra1 = $scope.setdisp.setextra1 == null ? "" : $scope.setdisp.setextra1;
			$scope.cusextra2 = $scope.setdisp.setextra2 == null ? "" : $scope.setdisp.setextra2;
			$scope.cusextra1r = $scope.setdisp.setextra1r == null ? "" : $scope.setdisp.setextra1r;
			$scope.cusextra2r = $scope.setdisp.setextra2r == null ? "" : $scope.setdisp.setextra2r;
			$scope.cusinterval = $scope.setdisp.setint == null ? 3 : $scope.setdisp.setint;
			$scope.cusdestimg = $scope.setdisp.setdestimg == null ? 0 : $scope.setdisp.setdestimg;
			$scope.cusextra1img = $scope.setdisp.setextra1img == null ? 0 : $scope.setdisp.setextra1img;
			$scope.cusextra2img = $scope.setdisp.setextra2img == null ? 0 : $scope.setdisp.setextra2img;
			$scope.cusrouteimg = $scope.setdisp.setrouteimg == null ? 0 : $scope.setdisp.setrouteimg;
			this.cusimg("cus_destimg",$scope.cusdestimg);
			this.cusimg("cus_extra1img",$scope.cusextra1img);
			this.cusimg("cus_extra2img",$scope.cusextra2img);
			this.cusimg("cus_routeimg",$scope.cusrouteimg);
		  };
		  this.loadsetting = function () {
			  $scope.cusrouteno = $scope.appSettings[$scope.selectedId].saveno;
			  $scope.cusdest = $scope.appSettings[$scope.selectedId].savedest;
				$scope.cuscolor = {
				  red: hexToRgb($scope.appSettings[$scope.selectedId].savecolour).r,
				  green: hexToRgb($scope.appSettings[$scope.selectedId].savecolour).g,
				  blue: hexToRgb($scope.appSettings[$scope.selectedId].savecolour).b
				};
				$scope.cusextra1 = $scope.appSettings[$scope.selectedId].saveextra1 == null ? "" : $scope.appSettings[$scope.selectedId].saveextra1;
				$scope.cusextra2 = $scope.appSettings[$scope.selectedId].saveextra2 == null ? "" : $scope.appSettings[$scope.selectedId].saveextra2;
				$scope.cusextra1r = $scope.appSettings[$scope.selectedId].saveextra1r == null ? "" : $scope.appSettings[$scope.selectedId].saveextra1r;
				$scope.cusextra2r = $scope.appSettings[$scope.selectedId].saveextra2r == null ? "" : $scope.appSettings[$scope.selectedId].saveextra2r;
				$scope.cusinterval = $scope.appSettings[$scope.selectedId].saveint == null ? 3 : $scope.appSettings[$scope.selectedId].saveint;
				$scope.cusdestimg = $scope.appSettings[$scope.selectedId].savedestimg == null ? 0 : $scope.appSettings[$scope.selectedId].savedestimg;
				$scope.cusextra1img = $scope.appSettings[$scope.selectedId].saveextra1img == null ? 0 : $scope.appSettings[$scope.selectedId].saveextra1img;
				$scope.cusextra2img = $scope.appSettings[$scope.selectedId].saveextra2img == null ? 0 : $scope.appSettings[$scope.selectedId].saveextra2img;
				$scope.cusrouteimg = $scope.appSettings[$scope.selectedId].saverouteimg == null ? 0 : $scope.appSettings[$scope.selectedId].saverouteimg;
				this.cusimg("cus_destimg",$scope.cusdestimg);
				this.cusimg("cus_extra1img",$scope.cusextra1img);
				this.cusimg("cus_extra2img",$scope.cusextra2img);
				this.cusimg("cus_routeimg",$scope.cusrouteimg);
				this.setcusdisp();
		  };
		  this.selecticon = function(icon,iconbtn) {
			  if ($scope.selectedicon == icon) {
			  $scope.selectedicon = "";
			  document.getElementById(iconbtn).style.border = "0px solid";
			  } else {
			  $scope.selectedicon = icon;
			  document.getElementById('icon_bng').style.border = "0px solid";
			  document.getElementById('icon_air').style.border = "0px solid";
			  document.getElementById('icon_bus').style.border = "0px solid";
			  document.getElementById('icon_rotl').style.border = "0px solid";
			  document.getElementById('icon_rotr').style.border = "0px solid";
			  document.getElementById(iconbtn).style.border = "5px solid #FF6600";
			  }
		  };
		  this.addicon = function(item) {
			  if (item == "cus_routeno") {
				  $scope.cusrouteno += $scope.selectedicon;
			  } else if (item == "cus_dest") {
				  $scope.cusdest += $scope.selectedicon;
			  } else if (item == "cus_extra1") {
				  $scope.cusextra1 += $scope.selectedicon;
			  } else if (item == "cus_extra2") {
				  $scope.cusextra2 += $scope.selectedicon;
			  } else if (item == "cus_extra1r") {
				  $scope.cusextra1r += $scope.selectedicon;
			  } else if (item == "cus_extra2r") {
				  $scope.cusextra2r += $scope.selectedicon;
			  }
			  $scope.selectedicon = "";
			  document.getElementById('icon_bng').style.border = "0px solid";
			  document.getElementById('icon_air').style.border = "0px solid";
			  document.getElementById('icon_bus').style.border = "0px solid";
			  document.getElementById('icon_rotl').style.border = "0px solid";
			  document.getElementById('icon_rotr').style.border = "0px solid";
		  };
		  this.cusimgfolder = function() {
			  const imgpath = "/settings/BusDispCtrl/image/";
			bngApi.engineLua('if not FS:directoryExists("' + imgpath + '") then FS:directoryCreate("' + imgpath + '", true) end');
			bngApi.engineLua('Engine.Platform.exploreFolder("' + imgpath + '")');
		  };
	},
    controllerAs: 'ctrl'
  };
}])